<template>
    <div class="relative" @click="toggleDropdown" ref="dropdown">

      <v-menu transition="fab-transition">
        <template v-slot:activator="{ props }">
          <v-btn
            variant="plain" size="small" style="padding: 0 !important;"
            v-bind="props"
          >
            <v-icon icon="mdi-web" /><span>{{ translate('languages.' + recentlySelected) }}</span>
          </v-btn>
        </template>
        <v-list>
          <v-list-item
            v-for="locale in filteredLocales"
            :key="`lang-${locale}}`"
            @click="switchLocale(locale)"
          >
            <v-list-item-title :v-text="locale">{{ translate('languages.' + locale) }}</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>

    </div>
</template>

<script lang="ts" setup>
import { ref, onMounted, computed } from 'vue';
import { useI18n } from 'vue-i18n';
import { StoreFactory } from '@/stores';
import { onClickOutside } from '@vueuse/core';
import { translate } from '@intlify/core-base'

const { t: translate } = useI18n();

const props = defineProps({
    languages: {
        type: Array,
        required: true,
    },
});

const dropdown = ref();
const i18n = useI18n();
let allLocales = ['pl', 'en'];

const menuOpen = ref(false);
const configStore = StoreFactory.configStore;
const recentlySelected = ref(configStore.locale);

const toggleDropdown = () => {
    menuOpen.value = !menuOpen.value;
};

const closeDropdown = () => {
    menuOpen.value = false;
};

const switchLocale = (locale: any) => {
    configStore.setLocale(locale);
    i18n.locale.value = locale;
  recentlySelected.value = locale;
    toggleDropdown();
};

const filteredLocales = computed(() => {
    return allLocales.filter((item) => item !== recentlySelected.value);
});

onClickOutside(dropdown, closeDropdown);

onMounted(() => {
    i18n.locale.value = recentlySelected.value;
});
</script>
